class Polinomio {
	private double[] coeff;
	
	public Polinomio(double[] c) {
		// considero che l'indice del coefficiente corrisponda al grado del monomio corrispondente
		coeff = c;
	}
	
	public String toString() {
		String p = "";
		for (int g = coeff.length-1; g >= 0; g--) {
			// scorro coeff[] al contrario...
			p += " + " + coeff[g] + "x^" + g;
		}
		
		return p;
	}
	
	public double[] getCoeff() {
		return coeff;
	}
	
	public Polinomio somma(Polinomio p){
		double[] nuoviCoeff; // qui metto il risultato della somma...
		double[] c = p.getCoeff();
		
		// nuoviCoeff e' relativo al polinomio di grado max
		if (coeff.length >= c.length)
			nuoviCoeff = new double[coeff.length];
		else
			nuoviCoeff = new double[c.length];
		
		// effettuo la somma coefficiente per coefficiente
		for (int g = 0; g < nuoviCoeff.length; g++) {
			nuoviCoeff[g] = 0;
			if (coeff.length > g)
				nuoviCoeff[g] += coeff[g];
			if (c.length > g)
				nuoviCoeff[g] += c[g];
		}
		
		// ritorno il polinomio risultato
		return new Polinomio(nuoviCoeff);
	}
	
	public Polinomio sottrai(Polinomio p){
		double[] nuoviCoeff; // qui metto il risultato della somma...
		double[] c = p.getCoeff();
		
		// nuoviCoeff e' relativo al polinomio di grado max
		if (coeff.length >= c.length)
			nuoviCoeff = new double[coeff.length];
		else
			nuoviCoeff = new double[c.length];
		
		// effettuo la somma coefficiente per coefficiente
		for (int g = 0; g < nuoviCoeff.length; g++) {
			nuoviCoeff[g] = 0;
			if (coeff.length > g)
				nuoviCoeff[g] += coeff[g];
			if (c.length > g)
				nuoviCoeff[g] -= c[g];
		}
		
		// ritorno il polinomio risultato
		return new Polinomio(nuoviCoeff);
	}
	
	public Polinomio derivata() {
		double[] nuoviCoeff = new double[coeff.length-1]; // coefficienti della derivata
		
		for (int g = 0; g < nuoviCoeff.length; g++)
			nuoviCoeff[g] = coeff[g+1]*(g+1);
		
		return new Polinomio(nuoviCoeff);
		
	}

	public Polinomio integrale() {
		double[] nuoviCoeff = new double[coeff.length+1]; // coefficienti dell'integrale
		nuoviCoeff[0] = 0; // considero l'integrale con costante = 0
		
		for (int g = 1; g < nuoviCoeff.length; g++)
			nuoviCoeff[g] = coeff[g-1]/g;
		
		return new Polinomio(nuoviCoeff);
		
	}

	public static void main(String[] args) {
		double[] c1 = {1.5, 3, 2.5, 5};
		double[] c2 = {1, 4, 3, 0, 4};
		
		Polinomio p1 = new Polinomio(c1);
		Polinomio p2 = new Polinomio(c2);

		System.out.println("Polinomio 1: " + p1);
		System.out.println("Polinomio 2: " + p2);

		System.out.println("\nSomma polinomio 1+2: " + p1.somma(p2));
		System.out.println("Differenza polinomio 1-2: " + p1.sottrai(p2));

		System.out.println("\nDerivata polinomio 1: " + p1.derivata());
		System.out.println("Integrale polinomio 2: " + p2.integrale());
		
		System.out.println("\nDerivata dell'integrale del polinomio 2: " + p2.integrale().derivata());		
	}
}
